require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "android.widget.EditText"
import "android.text.InputType"
import "android.widget.TextView"
import "android.widget.Button"
import "android.view.View"
import "android.widget.LinearLayout"
import "android.R$layout"
import "android.graphics.Color"
import "android.graphics.drawable.GradientDrawable"
import "android.graphics.Typeface"

local 屏幕宽度 = activity.getResources().getDisplayMetrics().widthPixels
local 屏幕高度 = activity.getResources().getDisplayMetrics().heightPixels
local 边距 = 20
local 目标数字
local 尝试次数 = 0
local 当前关卡 = 1
local 最大关卡 = 1000
local 游戏分数 = 0
local 游戏中 = false
local 已解锁关卡 = 1
local 最小范围 = 1
local 最大范围 = 100
local 游戏模式 = "关卡"
local 分数文件 = activity.getLuaDir().."/score.txt"
local 解锁文件 = activity.getLuaDir().."/unlock.txt"
local 自定义最小值 = 1
local 自定义最大值 = 100

local 颜色表 =
{
  "#FFEB3B",
  "#FFC107",
  "#FF9800",
  "#FF5722",
  "#F44336",
  "#E91E63",
  "#9C27B0",
  "#673AB7",
  "#3F51B5",
  "#2196F3",
  "#03A9F4",
  "#00BCD4",
  "#009688",
  "#4CAF50",
  "#8BC34A",
  "#CDDC39"
}

local 关卡配置表 = {}
for i=1, 最大关卡 do
  local 最小 = 1
  local 最大 = 100 + (i-1)*20
  local 颜色索引 = (i-1)%#颜色表 + 1
  local 文字色 = i%3 == 0 and "#FFFFFF" or "#000000"
  关卡配置表[i] =
  {
    最小 = 最小,
    最大 = 最大,
    背景色 = 颜色表[颜色索引],
    文字色 = 文字色,
    提示 = i <= 100 and "初级难度" or
    i <= 300 and "中级难度" or
    i <= 600 and "高级难度" or
    i <= 800 and "终级难度" or
    i <= 1000 and "专家难度" or "地狱难度"
  }
end

function 创建圆角背景(颜色, 圆角半径)
  local 背景 = GradientDrawable()
  背景.setShape(GradientDrawable.RECTANGLE)
  背景.setColor(Color.parseColor(颜色))
  背景.setCornerRadius(圆角半径)
  return 背景
end

function 读取文件(文件名)
  local 文件 = io.open(文件名, "r")
  if 文件 then
    local 内容 = 文件:read("*a")
    文件:close()
    return tonumber(内容) or 0
  end
  return 0
end

function 写入文件(文件名, 内容)
  local 文件 = io.open(文件名, "w")
  if 文件 then
    文件:write(tostring(内容))
    文件:close()
  end
end

function 检查数字长度(数字)
  return tostring(数字):len() <= 10
end

function 生成目标数字()
  if 游戏模式 == "随机" then
    最小范围 = 1
    最大范围 = math.random(2, 10000000000000000)
    目标数字 = math.random(最小范围, 最大范围)
   elseif 游戏模式 == "自定义" then
    最小范围 = 自定义最小值
    最大范围 = 自定义最大值
    目标数字 = math.random(最小范围, 最大范围)
   else
    local 当前配置 = 关卡配置表[当前关卡]
    最小范围 = 当前配置.最小
    最大范围 = 当前配置.最大
    目标数字 = math.random(最小范围, 最大范围)
  end
end

function 检查猜测(猜测数字)
  if not 猜测数字 then
    return
  end
  if 猜测数字 == 目标数字 then
    if 游戏模式 == "关卡" then
      游戏分数 = 游戏分数 + (最大范围 - 最小范围) / 100 * (100 - 尝试次数)
      写入文件(分数文件, 游戏分数)
      if 当前关卡 == 已解锁关卡 and 当前关卡 < 最大关卡 then
        已解锁关卡 = 已解锁关卡 + 1
        写入文件(解锁文件, 已解锁关卡)
      end
    end
    local 提示信息 = string.format("恭喜你猜对了！\n目标数字: %d。\n尝试次数: %d。", 目标数字, 尝试次数)
    if 游戏模式 == "关卡" then
      提示信息 = 提示信息..string.format("\n当前分数: %.1f", 游戏分数)
    end
    local 对话框 = AlertDialog.Builder(activity)
    .setTitle("猜对了！")
    .setMessage(提示信息)
    .setPositiveButton("确定",
    {
      onClick = function()
        if 游戏模式 == "关卡" and 当前关卡 < 最大关卡 then
          当前关卡 = 当前关卡 + 1
          生成目标数字()
        end
        尝试次数 = 0
        更新界面()
      end
    })
    .create()
    对话框.show()
   else
    local 提示方向 = 猜测数字 < 目标数字 and "小了" or "大了"
    if 猜测数字 < 目标数字 then
      最小范围 = math.max(最小范围, 猜测数字)
     else
      最大范围 = math.min(最大范围, 猜测数字)
    end
    显示提示对话框(string.format("你猜的数字%s，当前猜测范围：%d-%d。", 提示方向, 最小范围, 最大范围))
  end
  尝试次数 = 尝试次数 + 1
end

function 显示提示对话框(消息)
  local 对话框 = AlertDialog.Builder(activity)
  .setTitle("提示")
  .setMessage(消息)
  .setPositiveButton("确定", nil)
  .create()
  对话框.show()
end

function 显示模式选择()
  游戏分数 = 读取文件(分数文件)
  已解锁关卡 = math.max(1, 读取文件(解锁文件) or 1)
  local 布局 = LinearLayout(activity)
  布局.setOrientation(LinearLayout.VERTICAL)
  布局.setPadding(边距, 边距, 边距, 边距)
  布局.setBackgroundColor(Color.parseColor("#4444AAAA"))
  local 标题 = TextView(activity)
  标题.setText("选择游戏模式")
  标题.setTextSize(24)
  标题.setTypeface(nil, Typeface.BOLD)
  标题.setTextColor(Color.WHITE)
  标题.setGravity(Gravity.CENTER)
  布局.addView(标题)
  local 关卡模式按钮 = Button(activity)
  关卡模式按钮.setText(string.format("关卡模式 (已解锁%d关)", 已解锁关卡))
  关卡模式按钮.setTextSize(18)
  关卡模式按钮.setTextColor(Color.WHITE)
  关卡模式按钮.setBackground(创建圆角背景("#336699", 25))
  关卡模式按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      游戏模式 = "关卡"
      显示关卡选择()
    end
  })
  布局.addView(关卡模式按钮)
  local 娱乐模式按钮 = Button(activity)
  娱乐模式按钮.setText("娱乐模式 (所有关卡)")
  娱乐模式按钮.setTextSize(18)
  娱乐模式按钮.setTextColor(Color.WHITE)
  娱乐模式按钮.setBackground(创建圆角背景("#FF9900", 25))
  娱乐模式按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      游戏模式 = "娱乐"
      显示关卡选择()
    end
  })
  布局.addView(娱乐模式按钮)
  local 随机模式按钮 = Button(activity)
  随机模式按钮.setText("随机模式")
  随机模式按钮.setTextSize(18)
  随机模式按钮.setTextColor(Color.WHITE)
  随机模式按钮.setBackground(创建圆角背景("#228855", 25))
  随机模式按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      游戏模式 = "随机"
      游戏中 = true
      尝试次数 = 0
      生成目标数字()
      更新界面()
    end
  })
  布局.addView(随机模式按钮)
  local 自定义模式按钮 = Button(activity)
  自定义模式按钮.setText("自定义模式")
  自定义模式按钮.setTextSize(18)
  自定义模式按钮.setTextColor(Color.WHITE)
  自定义模式按钮.setBackground(创建圆角背景("#663388", 25))
  自定义模式按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      显示自定义设置()
    end
  })
  布局.addView(自定义模式按钮)
  activity.setContentView(布局)
end

function 显示自定义设置()
  local 布局 = LinearLayout(activity)
  布局.setOrientation(LinearLayout.VERTICAL)
  布局.setPadding(边距, 边距, 边距, 边距)
  布局.setBackgroundColor(Color.parseColor("#4444AAAA"))
  local 标题 = TextView(activity)
  标题.setText("自定义设置")
  标题.setTextSize(25)
  标题.setTypeface(nil, Typeface.BOLD)
  标题.setTextColor(Color.WHITE)
  标题.setGravity(Gravity.CENTER)
  布局.addView(标题)
  local 最小输入布局 = LinearLayout(activity)
  最小输入布局.setOrientation(LinearLayout.HORIZONTAL)
  local 最小标签 = TextView(activity)
  最小标签.setText("最小值:")
  最小标签.setTextSize(15)
  最小标签.setTextColor(Color.WHITE)
  最小标签.setPadding(0,0,10,0)
  最小输入布局.addView(最小标签)
  local 最小输入框 = EditText(activity)
  最小输入框.setInputType(InputType.TYPE_CLASS_NUMBER)
  最小输入框.setText("1")
  最小输入框.setTextSize(15)
  最小输入框.setBackground(创建圆角背景("#FFFFFF", 5))
  最小输入框.setPadding(10,10,10,10)
  最小输入布局.addView(最小输入框)
  布局.addView(最小输入布局)
  local 最大输入布局 = LinearLayout(activity)
  最大输入布局.setOrientation(LinearLayout.HORIZONTAL)
  local 最大标签 = TextView(activity)
  最大标签.setText("最大值:")
  最大标签.setTextSize(15)
  最大标签.setTextColor(Color.WHITE)
  最大标签.setPadding(0,0,10,0)
  最大输入布局.addView(最大标签)
  local 最大输入框 = EditText(activity)
  最大输入框.setInputType(InputType.TYPE_CLASS_NUMBER)
  最大输入框.setText("100")
  最大输入框.setTextSize(15)
  最大输入框.setBackground(创建圆角背景("#FFFFFF", 5))
  最大输入框.setPadding(10,10,10,10)
  最大输入布局.addView(最大输入框)
  布局.addView(最大输入布局)
  local 提示文本 = TextView(activity)
  提示文本.setText("最大值不能超过16位数字")
  提示文本.setTextSize(15)
  提示文本.setTextColor(Color.WHITE)
  提示文本.setGravity(Gravity.CENTER)
  布局.addView(提示文本)
  local 开始按钮 = Button(activity)
  开始按钮.setText("开始游戏")
  开始按钮.setTextSize(18)
  开始按钮.setTextColor(Color.WHITE)
  开始按钮.setBackground(创建圆角背景("#CCAA50", 10))
  开始按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      local 最小文本 = 最小输入框.getText().toString()
      local 最大文本 = 最大输入框.getText().toString()
      if #最大文本 > 16 then
        显示提示对话框("输入的数字过大，最大值不能超过16位数字，请重新输入。")
        return
      end
      自定义最小值 = tonumber(最小文本) or 1
      自定义最大值 = tonumber(最大文本) or 100
      if 自定义最大值 <= 自定义最小值 then
        显示提示对话框("最大值必须大于最小值")
        return
      end
      游戏模式 = "自定义"
      游戏中 = true
      尝试次数 = 0
      生成目标数字()
      更新界面()
    end
  })
  布局.addView(开始按钮)
  local 返回按钮 = Button(activity)
  返回按钮.setText("返回")
  返回按钮.setTextSize(16)
  返回按钮.setTextColor(Color.WHITE)
  返回按钮.setBackground(创建圆角背景("#9E9E9E", 10))
  返回按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      显示模式选择()
    end
  })
  布局.addView(返回按钮)
  activity.setContentView(布局)
end

function 显示关卡选择()
  local 布局 = LinearLayout(activity)
  布局.setOrientation(LinearLayout.VERTICAL)
  布局.setPadding(边距, 边距, 边距, 边距)
  local 当前配置 = 关卡配置表[1]
  布局.setBackgroundColor(Color.parseColor(当前配置.背景色))
  local 标题 = TextView(activity)
  标题.setText(游戏模式 == "关卡" and "选择关卡 (已解锁"..已解锁关卡.."关)" or "选择关卡 (娱乐模式)")
  标题.setTextSize(24)
  标题.setTypeface(nil, Typeface.BOLD)
  标题.setTextColor(Color.parseColor(当前配置.文字色))
  标题.setGravity(Gravity.CENTER)
  布局.addView(标题)
  local 分数显示 = TextView(activity)
  分数显示.setText(游戏模式 == "关卡" and string.format("当前分数: %.1f", 游戏分数) or "娱乐模式不计分")
  分数显示.setTextSize(16)
  分数显示.setTextColor(Color.parseColor(当前配置.文字色))
  分数显示.setGravity(Gravity.CENTER)
  布局.addView(分数显示)
  local 返回按钮 = Button(activity)
  返回按钮.setText("返回模式选择")
  返回按钮.setTextSize(16)
  返回按钮.setTextColor(Color.WHITE)
  返回按钮.setBackground(创建圆角背景("#9E9E9E", 10))
  返回按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      显示模式选择()
    end
  })
  布局.addView(返回按钮)
  local 滚动视图 = ScrollView(activity)
  local 关卡容器 = LinearLayout(activity)
  关卡容器.setOrientation(LinearLayout.VERTICAL)
  关卡容器.setGravity(Gravity.CENTER)
  local 每行按钮数 = 5
  local 当前行
  for 关卡序号 = 1, 最大关卡 do
    if (关卡序号-1) % 每行按钮数 == 0 then
      当前行 = LinearLayout(activity)
      当前行.setOrientation(LinearLayout.HORIZONTAL)
      当前行.setGravity(Gravity.CENTER)
      关卡容器.addView(当前行)
    end
    local 关卡按钮 = Button(activity)
    关卡按钮.setText(tostring(关卡序号))
    关卡按钮.setTextSize(14)
    关卡按钮.setPadding(10,10,10,10)
    local 关卡配置 = 关卡配置表[关卡序号]
    if 游戏模式 == "娱乐" or 关卡序号 <= 已解锁关卡 then
      关卡按钮.setBackground(创建圆角背景(关卡配置.背景色, 5))
      关卡按钮.setTextColor(Color.parseColor(关卡配置.文字色))
      关卡按钮.setOnClickListener(View.OnClickListener{
        onClick = function(v)
          当前关卡 = 关卡序号
          游戏中 = true
          尝试次数 = 0
          生成目标数字()
          更新界面()
        end
      })
     else
      关卡按钮.setBackground(创建圆角背景("#CCCCCC", 5))
      关卡按钮.setTextColor(Color.GRAY)
      关卡按钮.setEnabled(false)
    end
    当前行.addView(关卡按钮, ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT)
  end
  滚动视图.addView(关卡容器)
  布局.addView(滚动视图)
  activity.setContentView(布局)
end

function 更新界面()
  local 布局 = LinearLayout(activity)
  布局.setOrientation(LinearLayout.VERTICAL)
  布局.setPadding(边距, 边距, 边距, 边距)
  local 背景色 = "#2299ff"
  local 文字色 = "#FFFFFF"
  if 游戏模式 == "关卡" or 游戏模式 == "娱乐" then
    local 当前配置 = 关卡配置表[当前关卡]
    背景色 = 当前配置.背景色
    文字色 = 当前配置.文字色
  end
  布局.setBackgroundColor(Color.parseColor(背景色))
  local 标题 = TextView(activity)
  标题.setText(游戏模式 == "随机" and "随机模式" or 游戏模式 == "自定义" and "自定义模式" or string.format("第%d关", 当前关卡))
  标题.setTextSize(24)
  标题.setTypeface(nil, Typeface.BOLD)
  标题.setTextColor(Color.parseColor(文字色))
  标题.setGravity(Gravity.CENTER)
  布局.addView(标题)
  local 信息 = TextView(activity)
  信息.setText(string.format("范围：%d-%d。\n尝试次数：%d。", 最小范围, 最大范围, 尝试次数))
  if 游戏模式 == "关卡" then
    信息.setText(信息.getText()..string.format("\n当前分数: %.1f", 游戏分数))
  end
  信息.setTextSize(16)
  信息.setTextColor(Color.parseColor(文字色))
  信息.setGravity(Gravity.CENTER)
  布局.addView(信息)
  local 输入框 = EditText(activity)
  输入框.setInputType(InputType.TYPE_CLASS_NUMBER)
  输入框.setHint("输入你的猜测")
  输入框.setTextSize(18)
  输入框.setHintTextColor(Color.parseColor("#888888"))
  输入框.setTextColor(Color.parseColor("#333333"))
  输入框.setBackground(创建圆角背景("#FFFFFF", 25))
  输入框.setPadding(20, 20, 20, 20)
  输入框.setGravity(Gravity.CENTER)
  布局.addView(输入框)
  local 提交按钮 = Button(activity)
  提交按钮.setText("提交")
  提交按钮.setTextSize(18)
  提交按钮.setTextColor(Color.WHITE)
  提交按钮.setBackground(创建圆角背景("#AACC55", 10))
  提交按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      local 猜测数字 = tonumber(输入框.getText().toString())
      if not 猜测数字 then
        显示提示对话框("请输入有效的数字")
        return
      end
      检查猜测(猜测数字)
      更新界面()
    end
  })
  布局.addView(提交按钮)
  local 返回按钮 = Button(activity)
  返回按钮.setText("返回")
  返回按钮.setTextSize(16)
  返回按钮.setTextColor(Color.WHITE)
  返回按钮.setBackground(创建圆角背景("#9E9E9E", 25))
  返回按钮.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      游戏中 = false
      if 游戏模式 == "关卡" or 游戏模式 == "娱乐" then
        显示关卡选择()
       else
        显示模式选择()
      end
    end
  })
  布局.addView(返回按钮)
  activity.setContentView(布局)
end

显示模式选择()